
#ifndef IODEVICE_H
#define IODEVICE_H

#include <windows.h>
#include "InputDevice.h"
#include "InputSignal.h"

class IODevice
{

    public:
        virtual void reset() = 0;
        virtual void poll() = 0;
        virtual INT32 getControlCount() = 0;
        virtual void getControlDescription(INT32 controlNum, CHAR* desc) = 0;
        virtual void setControlInputSignal(INT32 controlNum,
                InputSignal* inputSignal) = 0;
        virtual void getControlInputSignal(INT32 controlNum,
                InputSignal** signal) = 0;
        virtual void setInputDevice(InputDevice* inputDevice) = 0;
        virtual INT32 getInputValue() = 0;
        virtual void setOutputValue(INT32 value) = 0;

};

#endif
