
#ifndef SPRITE_H
#define SPRITE_H

#include <windows.h>
#include "MOBRect.h"

class AY38900;
class AY38900_Registers;

class MOB
{

    friend class AY38900;
    friend class AY38900_Registers;

    private:
        MOB() {};
        void reset();
        void setXLocation(INT32 xLocation);
        void setYLocation(INT32 yLocation);
        void setForegroundColor(INT32 foregroundColor);
        void setCardNumber(INT32 cardNumber);
        void setVisible(BOOL isVisible);
        void setDoubleWidth(BOOL doubleWidth);
        void setDoubleYResolution(BOOL doubleYResolution);
        void setDoubleHeight(BOOL doubleHeight);
        void setQuadHeight(BOOL quadHeight);
        void setFlagCollisions(BOOL flagCollisions);
        void setHorizontalMirror(BOOL horizontalMirror);
        void setVerticalMirror(BOOL verticalMirror);
        void setBehindForeground(BOOL behindForeground);
        void setGROM(BOOL grom);
        void markClean();
        MOBRect* getBounds();
/*
        void save(SaveOutputStream os) throws IOException;
        void load(LoadInputStream is) throws IOException;
*/

        //other classes should always use the accessor to get this variable
        //Rectangle boundingRectangle = new Rectangle();

        INT32     xLocation;
        INT32     yLocation;
        INT32     foregroundColor;
        INT32     cardNumber;
        BOOL    isGrom;
        BOOL    isVisible;
        BOOL    doubleWidth;
        BOOL    doubleYResolution;
        BOOL    doubleHeight;
        BOOL    quadHeight;
        BOOL    flagCollisions;
        BOOL    horizontalMirror;
        BOOL    verticalMirror;
        BOOL    behindForeground;
        BOOL    boundsChanged;
        BOOL    changed;
        MOBRect    boundingRectangle;

};

#endif

