
#include "MemoryAlias.h"

void MemoryAlias::init(Memory* m, INT32 location) {
    this->aliasedMemory = m;
    this->location = location;
    this->offset = location - m->getLocation();
}

void MemoryAlias::reset() {
    visible = TRUE;
}

void MemoryAlias::setVisible(BOOL visible) {
    this->visible = visible;
}

BOOL MemoryAlias::isVisible() {
    return visible;
}

INT32 MemoryAlias::getLocation() {
    return location;
}

INT32 MemoryAlias::peek(INT32 location) {
    return (visible ? aliasedMemory->peek(location-offset) : location);
}

void MemoryAlias::poke(INT32 location, INT32 value) {
    //if (visible)
        aliasedMemory->poke(location-offset, value);
}

INT32 MemoryAlias::getSize() {
    return aliasedMemory->getSize();
}
