
#include <iostream>
#include "MemoryBus.h"

using namespace std;

MemoryBus::MemoryBus()
    : memory(NULL),
      mappedMemoryCount(0)
{
}

MemoryBus::MemoryBus(INT32 size)
    : memory(NULL),
      mappedMemoryCount(0)
{
   init(size);
}

void MemoryBus::init(INT32 size)
{
    this->size = size;
    memory = new Memory*[size];
    for (INT32 i = 0; i < size; i++)
        memory[i] = NULL;
}

MemoryBus::~MemoryBus()
{
    if (memory != NULL)
        delete[] memory;
}

void MemoryBus::reset()
{
    for (INT32 i = 0; i < mappedMemoryCount; i++)
        mappedMemories[i]->reset();
}

void MemoryBus::addMemory(Memory* m)
{
    mappedMemories[mappedMemoryCount] = m;
    mappedMemoryCount++;

    INT32 location = m->getLocation();
    INT32 end = location + m->getSize();
    for (INT32 i = location; i < end; i++)
        memory[i] = m;
}

void MemoryBus::removeMemory(Memory* m)
{
    for (INT32 i = 0; i < mappedMemoryCount; i++) {
        if (mappedMemories[i] == m) {
            INT32 j;
            for (j = i; j < (mappedMemoryCount-1); j++)
                mappedMemories[j] = mappedMemories[j+1];
            mappedMemoryCount--;

            INT32 location = m->getLocation();
            INT32 end = location + m->getSize();
            for (j = location; j < end; j++)
                memory[j] = NULL;
        }
    }

}

INT32 MemoryBus::getLocation()
{
    return 0;
}

INT32 MemoryBus::peek(INT32 location)
{
    if (memory[location] == NULL)
        return UNMAPPED_PEEK;

//if (location == 0x0102)
//cout << "$0102 read: " << memory[location]->peek(location) << "\n";

    return memory[location]->peek(location);
}

void MemoryBus::poke(INT32 location, INT32 value)
{
    if (memory[location] == NULL)
        return;

//if (location == 0x0102)
//cout << "$0102 write: " << value << "\n";

    memory[location]->poke(location, value);
}

INT32 MemoryBus::getSize()
{
    return size;
}
