
#ifndef CARTRIDGE_H
#define CARTRIDGE_H

#include "Peripheral.h"

class Cartridge : public Peripheral
{

    public:
        Cartridge(const CHAR* name, Memory** memories, INT32 memCount);
        Cartridge(const CHAR* name, Memory** memories, INT32 memCount,
                BOOL requiresECS, BOOL usesIntellivoice);
        ~Cartridge();
        const CHAR* getName();
        INT32 getProcessorCount();
        void getProcessor(INT32 i, Processor** p);
        INT32 getMemoryCount();
        void getMemory(INT32 i, Memory** m);
        BOOL requiresECS();
        BOOL usesIntellivoice();
        static Cartridge* loadCartridge(const CHAR* filename);

    private:
        const CHAR*    name;
        Memory**       memories;
        INT32          memCount;
        BOOL           ecs;
        BOOL           ivoice;

};

#endif
