
#ifndef CARTRIDGETYPE_H
#define CARTRIDGETYPE_H

#include <windows.h>
#include "MemorySpan.h"

class CartridgeType
{

    public:
        CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
                UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
                UINT32 spanStart1, UINT32 spanEnd1);
        CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
                UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
                UINT32 spanStart1, UINT32 spanEnd1,
                UINT32 spanStart2, UINT32 spanEnd2);
        CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
                UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
                UINT32 spanStart1, UINT32 spanEnd1,
                UINT32 spanStart2, UINT32 spanEnd2,
                UINT32 spanStart3, UINT32 spanEnd3);
        CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
                UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
                UINT32 spanStart1, UINT32 spanEnd1,
                UINT32 spanStart2, UINT32 spanEnd2,
                UINT32 spanStart3, UINT32 spanEnd3,
                UINT32 spanStart4, UINT32 spanEnd4);
        ~CartridgeType();
        UINT32 getCrc();
        const CHAR* getName();
        const CHAR* getProducer();
        const CHAR* getYear();
        UINT32 getSize();
        BOOL requiresECS();
        BOOL usesIntellivoice();
        UINT32 getMemorySpanCount();
        MemorySpan* getMemorySpan(UINT32 i);

    private:
        UINT32      crc;
        CHAR*       name;
        CHAR*       producer;
        CHAR*       year;
        UINT32      size;
        BOOL        ecs;
        BOOL        ivoice;
        MemorySpan* spans;
        UINT32      spanCount;

};

#endif

